import { DomSnapshot } from "./types";
export interface EditableSerializer<T> {
    data: (snapshot: DomSnapshot) => T;
    plain?: (snapshot: DomSnapshot) => string;
}
export interface EditableOptions<T> {
    multiline?: boolean;
    readonly?: boolean;
    serializer?: EditableSerializer<T>;
    onChange: (value: T) => void;
}
export interface EditableHandle {
    (): void;
    readonly: (value: boolean) => void;
}
export declare const editable: <T = string>(element: HTMLElement, { multiline, readonly, serializer, onChange, }: EditableOptions<T>) => EditableHandle;
